// tarjetas.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <iostream.h>
#include <Ltc2x.h>

void escribir_hex_u (unsigned char c);
void escribir_hex_u_v (unsigned char v[], int dimv);
void escribir_hex_v (char v[], int dimv);

int main(int argc, char* argv[])
{
	HANDLE idPort;
	char ATRL[80];
	unsigned char ATRT[80], SW[2], CLAVE[8], DATOS[80];
	int dimATRL, dimATRT, i;

	// Abrir Puerto de Comunicaciones
	idPort = C3OPEN ("COM1");	

	// Imprimir Identificador del Puerto
	cout << "Identificador del Puerto --> "<< idPort << endl << endl;

	// Reset del Lector
	C3RESET( idPort, &dimATRL, ATRL );
	
	// Imprimir ATR del Lector en formato ASCII
	cout << "ATR Lector  (ASCII) --> "<< ATRL << endl;

	// Imprimir ATR del Lector en formato hexadecimal
	cout << "ATR Lector  ( HEX ) --> ";
	escribir_hex_v (ATRL, dimATRL); cout << endl << endl;

	// Solicitar Insercin de Tarjeta
	C3INSERT( idPort, 0, 1000000 );

	// Solicitar Activar Tarjeta
 	C3POWERON( idPort, 0, 0, &dimATRT, ATRT, &SW[0], &SW[1] );

	// Imprimir ATR de la Tarjeta en formato ASCII
	cout << "ATR Tarjeta (ASCII) --> "<< ATRT << endl;

	// Imprimir ATR de la Tarjeta en formato hexadeciomal
	cout << "ATR Tarjeta ( HEX ) --> ";
	escribir_hex_u_v (ATRT, dimATRT); cout << endl << endl;

	// Obtener Numero de Serie
 	C3ISOOUT( idPort, 0, 0x00, 0x54, 0x00, 0x00, 0x08, DATOS, &SW[0], &SW[1], 1000000 );

	// Imprimir Resultado de Obtener Numero de Serie
	cout << "SW1-SW2 (Obtener Numero de Serie) --> "; 
	escribir_hex_u_v (SW, 2); cout << endl;
	
	// Imprimir Numero de Serie en formato hexadecimal
	cout << "Numero de Serie ( HEX ) --> ";
	escribir_hex_u_v (DATOS, 8); cout << endl << endl;

	// Crear Clave Maestra
	for (i=0; i<8; i++) CLAVE[i] = (unsigned char) 0x00;

	// Imprimir Clave Maestra en formato hexadecimal
	cout << "Valor de la Clave Maestra --> ";
	escribir_hex_u_v (CLAVE, 8); cout << endl;

	// Presentar Clave Maestra
	C3ISOIN( idPort, 0, 0x00, 0x48, 0x00, 0x00, 0x08, CLAVE, &SW[0], &SW[1], 1000000 );

	// Imprimir Resultado de Presentar Clave Maestra
	cout << "SW1-SW2 (Presentar Clave Maestra) --> "; 
	escribir_hex_u_v (SW, 2); cout << endl;

	cin >> i;

	// Solicitar Desactivar de Tarjeta
	C3POWEROFF( idPort, 0 );

	// Solicitar Extraccin de Tarjeta
	C3REMOVE( idPort, 0, 1000000 );

	// Cerrar Puerto Serie
	C3CLOSE (idPort);

	return 0;
}

void escribir_hex_u (unsigned char c)
{
	unsigned int i = (unsigned int) c;
	if (i < 16) cout << '0'; cout << hex << i;
}

void escribir_hex_u_v (unsigned char v[], int dimv)
{
	int i;
	escribir_hex_u (v[0]);
	for (i=1; i<dimv; i++)
		{ cout <<'-'; escribir_hex_u (v[i]); }
}

void escribir_hex_v (char v[], int dimv)
{
	int i;	
	escribir_hex_u ((unsigned char) v[0]);
	for (i=1; i<dimv; i++)
		{ cout <<'-'; escribir_hex_u ((unsigned char) v[i]); }
}

